@use '../../../global/styles/utilities' as *;
@use '../../../global/styles/styles-variables' as *;
@use './styles/progressbar.variables' as *;

:host {
  @include digi-progressbar--variables;

  @media (min-width: $digi--breakpoint--large) {
    --digi--progressbar--step--size: var(--digi--progressbar--step--size--large);
    --digi--progressbar--step--size--active: var(--digi--progressbar--step--size--active--large);
  }

  .digi-progressbar {
    font-size: var(--digi--progressbar--label--font-size);
    margin: var(--digi--progressbar--margin);

    &--secondary {
      --digi--progressbar--step--background--active: var(--digi--progressbar--step--background--secondary--active);
      --digi--progressbar--border-color--active: var(--digi--progressbar--border-color--secondary--active);
      --digi--progressbar--step--line--color--active: var(--digi--progressbar--step--line--color--secondary--active);
    }    

    &:not(.digi-progressbar--linear) {
      --digi--progressbar--step--line--color--active: var(--digi--progressbar--step--line--color);
    }
  }

  .digi-progressbar__label {
    font-family: var(--digi--global--typography--font-family--default);
    font-size: var(--digi--progressbar--label--font-size);
    line-height: var(--digi--typography--body--line-height--desktop);
    color: var(--digi--color--text--primary);
    margin: var(--digi--progressbar--label--margin);
  }

  .digi-progressbar__list {
    position: relative;
    display: inline-flex;
    list-style: none;
    padding: 0;
    margin: 0;

    display: grid;
    grid-template-columns: repeat(auto-fit, calc(var(--digi--progressbar--step--size) + var(--digi--progressbar--gap)));

    @media (min-width: $digi--breakpoint--medium) {
      --digi--progressbar--gap: var(--digi--progressbar--gap--medium);
    }
    @media (min-width: $digi--breakpoint--large) {
      --digi--progressbar--gap: var(--digi--progressbar--gap--large);
    }
    @media (min-width: $digi--breakpoint--x-large) {
      --digi--progressbar--gap: var(--digi--progressbar--gap--x-large);
    }
  }

  .digi-progressbar__step {
    position: relative;
    height: var(--digi--progressbar--step--size--active);

    &:last-child {
      width: var(--digi--progressbar--step--size--active);

      &::before {
        display: none;
      }
    }

    &::before {
      content: "";
      position: absolute;
      top: 50%;
      transform: translateY(-50%);
      display: inline-block;
      width: 100%;
      border-top: solid var(--digi--progressbar--step--line--width) var(--digi--progressbar--step--line--color);
    }

    &--active {
      --digi--progressbar--border-color: var(--digi--progressbar--border-color--active);
      --digi--progressbar--step--background: var(--digi--progressbar--step--background--active);
      --digi--progressbar--step--size: var(--digi--progressbar--step--size--active);
      --digi--progressbar--step--line--color: var(--digi--progressbar--step--line--color--active);

      .digi-progressbar__step-indicator {
        margin-left: calc((var(--digi--progressbar--step--size--large) - var(--digi--progressbar--step--size--active--large))/2);
      }
    }

    &--current {
      --digi--progressbar--step--line--color: var(--digi--progressbar--step--line--color--current);
    }
    
  }

  .digi-progressbar__step-indicator {
    content: "";
    position: absolute;
    display: inline-flex;
    align-items: center;
    justify-content: center;
    top: 50%;
    transform: translateY(-50%);
    width: var(--digi--progressbar--step--size);
    height: var(--digi--progressbar--step--size);
    border-radius: 50%;
    border: solid var(--digi--progressbar--border-width) var(--digi--progressbar--border-color);
    background: var(--digi--progressbar--step--background);
    
  }

  .digi-progressbar__step-number {
    @include digi--a11y--sr-only;
  }
  
}
